{***************************************************************************
 *                                                                         *
 *             Unit de gestion des E/S Disque de POWER-GRAPH              *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

UNIT PG_Disk;

INTERFACE

 USES
     DOS,
     Crt,
     Graph,

     Console,

     PG_Ptrs,
     PG_GrScr,
     PG_Parch,
     PG_TxScr;

 TYPE
     PGFile=FILE OF REAL;
     PGFile0=FILE;

 CONST
      PG_Version:BYTE=1;

 VAR
    PGPath:STRING;

    FUNCTION FileExists(s:STRING):BOOLEAN;
    PROCEDURE ListeRepert;
    PROCEDURE ChangeRep;
    PROCEDURE Save(l:ProjListPtr);
    PROCEDURE Load(VAR l:ProjListPtr);

IMPLEMENTATION

 TYPE tab=ARRAY[1..3] OF WORD;

 VAR Path:STRING;
     IOr:WORD;


 FUNCTION FileExists(s:STRING):BOOLEAN;

  VAR f:FILE;

  BEGIN
       ASSIGN(f,s);
       {$I-}
       RESET(f);
       CLOSE(f);
       {$I+}
       FileExists:=(IOResult=0);
  END; {FileExists}


 PROCEDURE ListeRepert;

  VAR DirInfo:SearchRec;
      FileParch:POINTER;
      i:INTEGER;
      RStop:BOOLEAN;
      Ch:CHAR;

  BEGIN
       GrayOnBlack;
       WINDOW(1,TreeHi+2,80,25);
       ClrScr;
       WRITELN('Rpertoire courant : ',Path);
       WINDOW(1,1,80,25);
       FindFirst(Path+'*.PGS',Archive, DirInfo);
       NewParch(FileParch,12,0);
       WHILE DosError = 0 DO BEGIN
             AddParchLines(FileParch,ParchLength(FileParch)+1,1);
             ParchWrite(FileParch,1,ParchLength(FileParch),DirInfo.Name);
             FindNext(DirInfo);
       END;
       i:=1;
       RStop:=FALSE;
       REPEAT
             ColorWin(2,TreeHi+3,14,25,Black);
             ParchDisplay(FileParch,1,i,2,TreeHi+3,14,25,LightGray,Black);
             Ch:=ReadKey;
             If Ch=#0 THEN Ch:=ReadKey;
             CASE Ch OF
                  #72 : IF i>1
                           THEN DEC(i);                             {haut}
                  #80 : IF i<ParchLength(FileParch)-22+TreeHi
                           THEN INC(i);                             {bas}
                  #73 : IF i>22-TreeHi
                           THEN DEC(i,22-TreeHi)                    {PgUp}
                           ELSE i:=1;
                  #81 : IF i<ParchLength(FileParch)-2*(22-TreeHi)+1 {PgDn}
                           THEN INC(i,22-TreeHi)
                           ELSE i:=ParchLength(FileParch)-22+TreeHi;
                  #27 : RStop:=TRUE;
             END;
       UNTIL RStop;
       DelParch(FileParch);
  END; {ListeRepert}


 PROCEDURE ChangeRep;

  VAR p:STRING;

  BEGIN
       GrayOnBlack;
       ClrScr;
       WRITELN(#10,#10,'Chemin d''accs courant : ',Path);
       WRITE(#10,'  Nouveau chemin : ');
       READLN(p);
       IF p<>'' THEN Path:=p;
       ClrScr;
  END;


 PROCEDURE Save(l:ProjListPtr);

   VAR f:PGFile0;
       s:STRING[8];
       r:INTEGER;
       Ch:CHAR;
       i:BYTE;
       PosNbProj:WORD;
       LongEqu:WORD;
       NbCond:WORD;
       NbProject:WORD;

      PROCEDURE SaveXYZ(VAR f:PGFile0;p:XYZPtr;VAR LongEqu:WORD);

        BEGIN
             IF p=NIL THEN EXIT;
             BlockWrite(f,P^.x,2);
             BlockWrite(f,P^.y,2);
             BlockWrite(f,P^.z,2);
             INC(LongEqu);
             SaveXYZ(f,P^.Next,LongEqu);
        END; {SaveXYZ}

      PROCEDURE SaveCondList(VAR f:PGFile0;eq:EquPtr);

        VAR LongCond,PosLongCond,LongEqu:WORD;
            i:BYTE;

        BEGIN
             IF eq=NIL THEN EXIT;
          {*** Nom Condition ***}
             BlockWrite(f,eq^.Name,LENGTH(eq^.Name)+1);
          {*** Rservation place pour LongCond ***}
             PosLongCond:=FILEPOS(f);
             r:=0;
             BlockWrite(f,r,2);
          {*** Ecriture condition ***}
             LongCond:=0;
             SaveXYZ(f,eq^.p,LongEqu);
          {*** Ecriture LongCond ***}
             SEEK(f,PosLongCond);
             BlockWrite(f,LongCond,2);
          {*** Condition suivante ***}
             SEEK(f,FileSize(f));
             INC(NbCond);
             SaveCondList(f,eq^.Next);
        END; {SaveCondList}


     PROCEDURE SaveProject(VAR f:PGFile0;n:ProjectPtr);

      VAR PosProject:WORD;
          i:BYTE;

      BEGIN
           IF n=NIL THEN EXIT;
        {*** Nom Surface ***}
           BlockWrite(f,n^.Name,LENGTH(n^.Name)+1);
        {*** Rservation place Couleur/longueur quation/NbConditions ***}
           PosProject:=FILEPOS(f);
           r:=0;
           BlockWrite(f,r,2);
           BlockWrite(f,r,2);
           BlockWrite(f,r,2);
        {*** Ecriture Equation et conditions ***}
           LongEqu:=0;
           SaveXYZ(f,n^.P,LongEqu);
           NbCond:=0;
           SaveCondList(f,n^.cond);
        {*** Ecriture couleur/longueur/NbConditions ***}
           SEEK(f,PosProject);
           BlockWrite(f,n^.coul,2);
           BlockWrite(f,LongEqu,2);
           BlockWrite(f,NbCond,2);
        {*** Surface suivante ***}
           SEEK(f,FileSize(f));
           INC(NbProject);
           SaveProject(f,n^.Next);
      END; {SaveProject}


   BEGIN
        GOTOXY(20,TreeHi+5);
        WRITE('Nom du fichier : ');READLN(s);
        Ch:='O';
        IF FileExists(path+s+'.PGS') THEN REPEAT
           WRITELN('Ce fichier existe !');
           WRITELN('On l''crase, dis ? ');
           Ch:=UpCase(ReadKey);
           UNTIL Ch IN ['O','N'];
           l:=NthProjList(l,Ord(PosInTree[1]));
        IF Ch<>'N' THEN BEGIN
           WRITELN('Je sauve "',l^.Name,'" dans ',path+s+'.PGS');
           REPEAT UNTIL KeyPressed;
           ASSIGN(f,path+s+'.PGS');
           REWRITE(f,1);
        {*** N de version du type de fichier ***}
           BlockWrite(f,PG_Version,1);
        {*** Nom du projet ***}
           BlockWrite(f,l^.Name,LENGTH(l^.Name)+1);
        {*** Palette graphique 16 couleurs ***}
           r:=SizeOf(Palette);
           BlockWrite(f,r,2);
           Blockwrite(f,l^.Pal,r);
        {*** Rservation place pour NbProject ***}
           PosNbProj:=FILEPOS(f);
           r:=0;
           BlockWrite(f,r,2);
        {*** Sauve Projet ***}
           NbProject:=0;
           SaveProject(f,l^.Proj);
        {*** Ecriture NbProject ***}
           SEEK(f,PosNbProj);
           BlockWrite(f,NbProject,2);
           CLOSE(f);
        END;
        ClrScr;
   END; {Save}


 PROCEDURE Load(VAR l:ProjListPtr);

   TYPE tabb=ARRAY[1..6] OF BYTE;

   VAR f:PGFile;
       s:STRING[12];
       r:REAL;
       i,j:BYTE;
       FichVersion:WORD;

      PROCEDURE LoadXYZ(VAR f:PGFile;VAR p:XYZPtr;Nb:WORD);

        VAR r:REAL;

        BEGIN
             IF Nb=0 THEN p:=NIL ELSE BEGIN
                NEW(p);
                READ(f,r);
                WITH p^ DO BEGIN
                                x:=tab(r)[1];
                                y:=tab(r)[2];
                                z:=tab(r)[3];
                                READ(f,c);
                           END; {with}
                LoadXYZ(f,p^.Next,Nb-1);
             END; {ifte}
        END; {LoadXYZ}

      PROCEDURE LoadCondList(VAR f:PGFile;VAR eq:EquPtr;Nb:WORD);

        VAR i,j:BYTE;

        BEGIN
             IF Nb=0 THEN eq:=NIL
                     ELSE BEGIN
                          NewEqu(eq);
                       {*** Lecture nom condition ***}
                           READ(f,r);
                           FOR i:=1 TO 6 DO
                               eq^.Name[i-1]:=CHAR(tabb(r)[i]);
                           FOR i:=1 TO tab(r)[1] DIV 6 DO
                               BEGIN
                                    READ(f,r);
                                    FOR j:=1 TO 6 DO
                                        eq^.Name[6*i+j-1]:=CHAR(tabb(r)[j]);
                               END;
                       {*** Lecture taille condition / lecture qu.}
                          READ(f,r);
                          LoadXYZ(f,eq^.p,tab(r)[1]);
                       {*** suivante ***}
                          LoadCondList(f,eq^.Next,Nb-1);
                     END; {ifte}
        END; {LoadCondList}


     PROCEDURE LoadProject(VAR f:PGFile;VAR n:ProjectPtr;Nb:WORD);

       VAR i,j:BYTE;

       BEGIN
            IF Nb=0 THEN n:=NIL ELSE BEGIN
               NEWProject(n);
            {*** Lecture nom surface ***}
               READ(f,r);
               FOR i:=1 TO 6 DO
                   n^.Name[i-1]:=CHAR(tabb(r)[i]);
               FOR i:=1 TO tabb(r)[1] DIV 6 DO
                   BEGIN
                        READ(f,r);
                        FOR j:=1 TO 6 DO
                            n^.Name[6*i+j-1]:=CHAR(tabb(r)[j]);
                   END;
            {*** Lecture Couleur/Longueur qu/Nb Conditions ***}
               READ(f,r);
               n^.Coul:=tab(r)[1];
               LoadXYZ(f,n^.p,tab(r)[2]);
               LoadCondList(f,n^.cond,tab(r)[3]);
               LoadProject(f,n^.next,Nb-1);
            END; {ifte}
       END; {LoadProject}


   BEGIN
        GOTOXY(20,TreeHi+5);
        WRITE('Nom du fichier : ');READLN(s);
        IF s='' THEN EXIT;
        ASSIGN(f,path+s+'.PGS');
        {$I-}
        RESET(f);
        IF IOResult<>0
           THEN BEGIN
                WRITELN(Path+s,'.PGS n''existe pas !');
                WRITELN('Pressez une touche');
                REPEAT UNTIL KEYPRESSED;
                ClrScr;
                EXIT;
                END
           ELSE BEGIN
                New(l);l^.Next:=NIL;
                END;
        {$I+}
      {*** Lecture N de version ***}
         READ(f,r);
         FichVersion:=tab(r)[1];
      {*** Lecture Nom projet ***}
         READ(f,r);
         FOR i:=1 TO 6 DO
             l^.Name[i-1]:=CHAR(tabb(r)[i]);
         FOR i:=1 TO tabb(r)[1] DIV 6 DO
             BEGIN
                  READ(f,r);
                  FOR j:=1 TO 6 DO
                      l^.Name[6*i+j-1]:=CHAR(tabb(r)[j]);
             END;
      {*** Lecture palette 16 couleurs ***}
         READ(f,r);
         l^.pal.Values.size:=tabb(r)[1];
         FOR i:=0 TO 4 DO
             l^.pal.Values.colors[i]:=tabb(r)[i+2];
         FOR i:=1 TO SizeOf(PaletteType) DIV 6 DO
               BEGIN
                    READ(f,r);
                    REAL(PTR(SEG(l^.Pal.Values),OFS(l^.Pal.Values)+6*i)^):=r;
               END;
       {** Identification couleurs **}
         FOR i:=1 TO MaxDeg DO
             FOR j:=1 TO NDegrade DO
                 IF ColList[j].Pal[0]=l^.Pal.Values.Colors[2+3*(i-1)]
                    THEN l^.Pal.Names[i]:=ColList[j].Name;
      {*** Lecture Nb de surface / lecture surfaces ***}
        READ(f,r);
        LoadProject(f,l^.Proj,tab(r)[1]);
        CLOSE(f);
        ClrScr;
   END; {Load}


BEGIN
     GetDir(0,Path);
     PGPath:=Path;
     IF Path[LENGTH(Path)]<>'\' THEN Path:=Path+'\';
     {$I-}
     ChDir(Path+'PGS');
     {$I+}
     IF IORESULT=0
        THEN Path:=Path+'PGS\';
END.
