UNIT ChgVar;

INTERFACE

 Uses
     PG_Calc,
     PG_Ptrs;


 PROCEDURE ChangeVar(VAR Q:XYZPtr;P:XYZPtr; Axx,Axy,Axz,Bx,
                                            Ayx,Ayy,Ayz,By,
                                            Azx,Azy,Azz,Bz:REAL);

 PROCEDURE XYZRotate(VAR Q:XYZPtr;P:XYZPtr;a,t,f:REAL);

IMPLEMENTATION

{********************* Procdures de base ***************************}

  PROCEDURE Multi_Lin(P:XYZPtr;VAR Q:XYZPtr;Ax,Ay,Az,B:REAL);
    { Q = Q + P * (Ax*X + Ay*Y + Az*Z + B) }

   VAR
      tP:XYZPol;

   BEGIN
        IF Q=NIL
           THEN NewXYZ(Q);
        tP:=P^;
        tP.Next:=NIL;
        tP.c:=B*tP.c;
        IF tP.c<>0
           THEN XYZAdd(Q,@tP);  { Q=Q+P*b }
        tP.c:=P^.c*Ax;
        IF tP.c<>0 THEN BEGIN
                             INC(tP.x);
                             XYZAdd(Q,@tP);  { Q=Q+P*(Ax*X) }
                        END;
        tP.c:=P^.c*Ay;
        tP.x:=P^.x;
        IF tP.c<>0 THEN BEGIN
                             INC(tP.y);
                             XYZAdd(Q,@tP);  { Q=Q+P*(Ay*Y) }
                        END;
        tP.c:=P^.c*Az;
        tP.y:=P^.y;
        IF tP.c<>0 THEN BEGIN
                             INC(tP.z);
                             XYZAdd(Q,@tP);  { Q=Q+P*(Az*Z) }
                        END;
        IF P^.Next<>NIL
           THEN Multi_Lin(P^.Next,Q,Ax,Ay,Az,B);
   END; {Multi_Lin}


 PROCEDURE ChangeVar(VAR Q:XYZPtr;P:XYZPtr; Axx,Axy,Axz,Bx,
                                            Ayx,Ayy,Ayz,By,
                                            Azx,Azy,Azz,Bz:REAL);
   { x = Axx*X' + Axy*Y' + Axz*Z' + Bx ; ... ;  Q(x') = P(x) }

  VAR
     Q1,Q2:XYZPtr;
     i:WORD;

  BEGIN
       IF Q=NIL
          THEN NewXYZ(Q);
       NewXYZ(Q1);
       Q2:=NIL;
       Q1^.c:=P^.c;
       FOR i:=1 TO P^.x DO
           BEGIN
                Multi_Lin(Q1,Q2,Axx,Axy,Axz,Bx);
                DelXYZ(Q1);
                Q1:=Q2;
                Q2:=NIL;
           END;
       FOR i:=1 TO P^.y DO
           BEGIN
                Multi_Lin(Q1,Q2,Ayx,Ayy,Ayz,By);
                DelXYZ(Q1);
                Q1:=Q2;
                Q2:=NIL;
           END;
       FOR i:=1 TO P^.z DO
           BEGIN
                Multi_Lin(Q1,Q2,Azx,Azy,Azz,Bz);
                DelXYZ(Q1);
                Q1:=Q2;
                Q2:=NIL;
           END;
       XYZPolyAdd(Q,Q1);
       DelXYZ(Q1);
       IF P^.Next<>NIL
          THEN ChangeVar(Q,P^.Next, Axx,Axy,Axz,Bx,
                                    Ayx,Ayy,Ayz,By,
                                    Azx,Azy,Azz,Bz);
  END; {ChangeVar}


{******************* Transformations mathmatiques **********************}


 PROCEDURE XYZTranslate(VAR Q:XYZPtr;P:XYZPtr;v:Vec3);

  BEGIN
       ChangeVar(Q,P,1,0,0,v[1],0,1,0,v[2],0,0,1,v[3]);
  END; {XYZTranslate}


 PROCEDURE XYZRotate(VAR Q:XYZPtr;P:XYZPtr;a,t,f:REAL);
   { alpha, thta, phi }

  VAR ct,st,
      cf,sf,
      ca,sa:REAL;

  BEGIN
       ct:=cos(t);st:=sin(t);
       cf:=cos(f);sf:=sin(f);
       ca:=cos(a);sa:=sin(a);
       Q:=NIL;
       ChangeVar(Q,P, ct*ct*sf*sf*(1-ca)+ca, st*ct*sf*sf*(ca-1)-cf*sa, sf*(ct*cf*(ca-1)+st*sa), 0,
                      st*ct*sf*sf*(ca-1)+cf*sa, st*st*sf*sf*(1-ca)+ca, sf*(cf*st*(1-ca)+ct*sa), 0,
                      sf*(cf*ct*(ca-1)-st*sa), sf*(st*cf*(1-ca)-ct*sa), 1+sf*sf*(ca-1), 0);
  END; {XYZRotate}

END.



