UNIT console;

INTERFACE

 USES
     Crt;

 TYPE Base=1..36;

  FUNCTION CvNBase(n:LONGINT;BaseA:Base):STRING;
    { Expression d'un LONGINT en base BaseA }

  FUNCTION CvBaseN(s:STRING;BaseD:Base):LONGINT;
    { Interprtation numrique d'une chaine en base BaseD }

  PROCEDURE Cadre(x1,y1,x2,y2:INTEGER;Opt:BYTE);
    { Opt : bit 0 = Simple / Double trait vertical
            bit 1 = Simple / Double trait horizontal }


  PROCEDURE GetTextWin(x1,y1,x2,y2:BYTE;VAR p:POINTER);
    { mmorise la fentre texte indique en mmoire ; renvoie un pointeur sur
      la zone rserve ; librer avec FreeTextWin }

  PROCEDURE PutTextWin(p:POINTER;x1,y1:BYTE);
    { place en (x1,y1) la fentre texte pointe par p }

  PROCEDURE FreeTextWin(VAR p:POINTER);
    { libre la place occupe par une fentre texte dans le tas }

  PROCEDURE ColorWin(x1,y1,x2,y2,BckCol:BYTE);
    { remplit une fentre texte en couleur BckCol }

  PROCEDURE FillWin(a,b,c,d,col:BYTE);

{---------------------------------------}

IMPLEMENTATION

 CONST Chiffre:STRING='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';


  FUNCTION Puis(x,y:LONGINT):LONGINT;

    BEGIN
         IF y=0 THEN Puis:=1
                ELSE Puis:=x*Puis(x,y-1);
    END;


  FUNCTION CvNBase;

   VAR c:STRING;

   FUNCTION CvNBase1(n:LONGINT;BaseA:Base):STRING;

     BEGIN
          IF n=0 THEN CvNBase1:='' ELSE
          CvNBase1:=CvNBase1(n DIV BaseA,BaseA)+Chiffre[(n mod BaseA)+1];
     END;{CvNBase1}

   BEGIN
        C:=CvNBase1(n,BaseA);
        IF c='' THEN CvNBase:='0' ELSE CvNBase:=c;
   END;{CvNBase}


  FUNCTION CvBaseN;

    VAR i:WORD;
        c:LONGINT;

    BEGIN
         C:=0;
         FOR i:=0 TO LENGTH(s)-1 DO
             C:=C+Puis(BaseD,i)*(POS(s[LENGTH(s)-i],Chiffre)-1);
         CvBaseN:=c;
    END;{CvBaseN}

PROCEDURE Cadre;

  VAR i:INTEGER;
      h,v,hg,hd,bg,bd:CHAR;


  BEGIN
       CASE Opt OF
            0 : BEGIN hg:='';hd:='';bg:='';bd:='';END;
            1 : BEGIN hg:='';hd:='';bg:='';bd:='';END;
            2 : BEGIN hg:='';hd:='';bg:='';bd:='';END;
            3 : BEGIN hg:='';hd:='';bg:='';bd:='';END;
       END;
       IF (Opt AND 1)<>0 THEN v:='' ELSE v:='';
       IF (Opt AND 2)<>0 THEN h:='' ELSE h:='';
       GOTOXY(x1,y1);WRITE(hg);
       GOTOXY(x2,y1);WRITE(hd);
       GOTOXY(x1,y2);WRITE(bg);
       GOTOXY(x2,y2);WRITE(bd);

       GOTOXY(x1+1,y1);
       FOR i:=x1+1 to x2-1 DO WRITE(h);
       GOTOXY(x1+1,y2);
       FOR i:=x1+1 to x2-1 DO WRITE(h);

       FOR i:=y1+1 to y2-1 DO BEGIN
           GOTOXY(x1,i);WRITE(v);
           GOTOXY(x2,i);WRITE(v);
           END;
  END; {Cadre}


  PROCEDURE GetTextWin(x1,y1,x2,y2:BYTE;VAR p:POINTER);

   VAR Screen:ARRAY[1..25,1..80] OF WORD ABSOLUTE $B800:$0;
       x,y:BYTE;
       t:word;

   BEGIN
        GetMem(p,2*(x2-x1+1)*(y2-y1+1)+2);
        WORD(p^):=256*(x2-x1)+(y2-y1);
        FOR y:=y1 TO y2 DO
            FOR x:=x1 to x2 DO
                MEMW[SEG(p^):OFS(p^)+2+2*(x-x1)+2*(x2-x1+1)*(y-y1)]:=Screen[y,x];
   END; {GetTextWin}


  PROCEDURE PutTextWin(p:POINTER;x1,y1:BYTE);

   VAR Screen:ARRAY[1..25,1..80] OF WORD ABSOLUTE $B800:$0;
       x,y:BYTE;

   BEGIN
        FOR y:=y1 TO y1+BYTE(p^) DO
            FOR x:=x1 TO x1+HI(WORD(p^)) DO
                Screen[y,x]:=MEMW[SEG(p^):OFS(p^)+2+2*(x-x1)+2*(HI(WORD(p^))+1)*(y-y1)];
   END; {PutTextWin}


  PROCEDURE FreeTextWin(VAR p:POINTER);

   BEGIN
        FREEMEM(p,(BYTE(p^)+1)*(HI(WORD(p^))+1)*2+2);
   END; {FreeTextWin}


  PROCEDURE ColorWin(x1,y1,x2,y2,BckCol:BYTE);

   VAR i,j:BYTE;

   BEGIN
        FOR i:=y1 TO y2 DO
            FOR j:=x1 TO x2 DO
                MEM[$B800:2*(80*(i-1)+j)-1]:=BckCol*$10;
   END; {ColorWin}


  PROCEDURE FillWin(a,b,c,d,col:BYTE);

   VAR i,j:BYTE;

   BEGIN
        TextBackGround(col);
        FOR i:=b TO d DO BEGIN
            GOTOXY(a,i);
            FOR j:=a TO c DO
                WRITE(' ');
            END;
   END; {FillWin}

END.
