{$A+,B-,D+,E-,F-,G-,I+,L+,N-,O-,R+,S+,V+,X-}

{****************************************************************************
*                                                                           *
*                   Unit de gestion de fentres texte                      *
*                                                                           *
*             Freeware in the Boquette by Dwitch  132 An 191                *
*                                                                           *
*                              Juin 1992                                    *
*                                                                           *
*****************************************************************************}


UNIT DTWin;

 INTERFACE

  USES
      Crt,
      Console,
      PG_Parch;

  TYPE
      TWinPtr=^TWin;
      TWin=RECORD
                 X1,Y1,X2,Y2:BYTE;     {Positions cadre dans cran}
                 XPos,YPos:WORD;       {Position de fentre dans page}
                 Visible:BOOLEAN;
                 Cadre:BYTE;
                 TextCol,
                 BckCol:BYTE;
                 Page:POINTER;         {Pointeur du parchemin}
                 Cache:POINTER;        {Ecran  restituer}
                 END;


  CONST
       Cadre=0;
       DoubleVert=1;
       DoubleHoriz=2;
       PasDeCadre=255;

       Restore:BOOLEAN=TRUE;

  PROCEDURE OpenTWin(VAR p:TWinPtr;X1,Y1,X2,Y2:BYTE;_Cadre:BYTE;
                                LargPage,LongPage:WORD);
  PROCEDURE CloseTWin(VAR p:TWinPtr);
  PROCEDURE RefreshTWin(p:TWinPtr);
  PROCEDURE HydeTWin(p:TwinPtr);
  PROCEDURE ClearTWin(p:TWinPtr);
  PROCEDURE ResetTWin(p:TWinPtr;Largeur,Longueur:BYTE);
  PROCEDURE TWinWrite(p:TWinPtr;x,y:BYTE;s:STRING);
  PROCEDURE ScrollTWin(p:TWinPtr;dx,dy:INTEGER);
  PROCEDURE ModifTWin(p:TWinPtr;x1,y1,x2,y2,_Cadre,XPos,YPos:BYTE);
  PROCEDURE AddTWinLines(p:TWinPtr;YPos,NLines:BYTE);
  PROCEDURE DelTWinLines(p:TWinPtr;Li,NLines:BYTE);
  PROCEDURE SetTWinColor(p:TWinPtr;TextCol,BckCol:BYTE);


 IMPLEMENTATION

  CONST
       DefaultTextCol=Black;
       DefaultBckCol=LightGray;


  PROCEDURE OpenTWin(VAR p:TWinPtr;X1,Y1,X2,Y2,_Cadre:BYTE;
                                         LargPage,LongPage:WORD);

   BEGIN
        NEW(p);
        p^.x1:=x1;
        p^.x2:=x2;
        p^.y1:=y1;
        p^.y2:=y2;
        p^.Xpos:=1;
        p^.YPos:=1;
        p^.Cadre:=_Cadre;
        p^.BckCol:=DefaultBckCol;
        p^.TextCol:=DefaultTextCol;
        NewParch(p^.Page,LargPage,LongPage);
        p^.Visible:=FALSE;
        RefreshTWin(p);
   END; {OpenTWin}


  PROCEDURE CloseTWin(VAR p:TWinPtr);

   BEGIN
        WITH p^ DO BEGIN
             IF Visible
                THEN BEGIN
                          IF Restore
                             THEN PutTextWin(Cache,x1,y1);
                          FreeTextWin(p^.Cache);
                     END;
             DelParch(Page);
        END;
        DISPOSE(p);
   END; {CloseTWin}


  PROCEDURE RefreshTWin(p:TWinPtr);

   BEGIN
        WITH p^ DO BEGIN
             IF NOT(Visible)
                THEN BEGIN
                          GetTextWin(x1,y1,x2,y2,Cache);
                          Visible:=TRUE;
                          FillWin(x1,y1,x2,y2,BckCol);
                     END
                ELSE
                    ColorWin(x1,y1,x2,y2,BckCol);
             TextColor(TextCol);
             TextBackGround(BckCol);
             IF Cadre=PasDeCadre
                THEN ParchDisplay(Page,XPos,YPos,x1,y1,x2,y2,TextCol,BckCol)
                ELSE BEGIN
                          Console.Cadre(x1,y1,x2,y2,Cadre);
                          ParchDisplay(Page,XPos,YPos,x1+1,y1+1,x2-1,y2-1,TextCol,BckCol);
                     END;
        END;
   END; {RefreshTWin}


  PROCEDURE HydeTWin(p:TwinPtr);

   BEGIN
        WITH p^ DO BEGIN
                        IF NOT(Visible) THEN EXIT;
                        PutTextWin(Cache,X1,Y1);
                        FreeTextWin(Cache);
                        Visible:=FALSE;
                   END;
   END; {HydeTWin}


  PROCEDURE TWinWrite(p:TWinPtr;x,y:BYTE;s:STRING);

   BEGIN
        ParchWrite(p^.Page,x,y,s);
        IF p^.Visible THEN RefreshTWin(p);
   END; {TWinWrite}


  PROCEDURE ClearTWin(p:TWinPtr);

   BEGIN
        ClearParch(p^.Page);
        IF p^.Visible THEN RefreshTWin(p);
   END; {ClearTWin}


  PROCEDURE ResetTWin(p:TWinPtr;Largeur,Longueur:BYTE);

   BEGIN
        IF p^.Page=NIL THEN EXIT;
        DelParch(p^.Page);
        NewParch(p^.Page,Largeur,Longueur);
        IF p^.Visible THEN RefreshTWin(p);
   END;


  PROCEDURE ScrollTWin(p:TWinPtr;dx,dy:INTEGER);

   VAR
      Corr:BYTE;

   BEGIN
        WITH p^ DO BEGIN
             IF Cadre=PasDeCadre
                THEN Corr:=0
                ELSE Corr:=2;
             IF ((dx<0)AND(XPos>-dx)) OR
                 ((dx>0)AND(XPos+dx+x2-x1-1-Corr<ParchWidth(Page)))
                THEN XPos:=XPos+dx;
             IF ((dy<0)AND(yPos>-dy)) OR
                 ((dy>0)AND(yPos+dy+y2-y1-1-Corr<ParchLength(Page)))
                THEN yPos:=yPos+dy;
             IF Visible THEN RefreshTWin(p);
        END;
   END; {ScrollTWin}


  PROCEDURE ModifTWin(p:TWinPtr;x1,y1,x2,y2,_Cadre,XPos,YPos:BYTE);

   BEGIN
        HydeTWin(p);
        p^.x1:=x1;
        p^.x2:=x2;
        p^.y1:=y1;
        p^.y2:=y2;
        p^.Cadre:=_Cadre;
        p^.Xpos:=XPos;
        p^.YPos:=YPos;
        IF p^.Visible THEN RefreshTWin(p);
   END; {ModifTWin}


  PROCEDURE AddTWinLines(p:TWinPtr;YPos,NLines:BYTE);

   BEGIN
        AddParchLines(p^.Page,YPos,NLines);
        IF p^.Visible THEN RefreshTWin(p);
   END; {AddTWinLines}


  PROCEDURE DelTWinLines(p:TWinPtr;Li,NLines:BYTE);

   BEGIN
        DelParchLines(p^.Page,Li,Li+NLines-1);
        IF p^.Visible THEN RefreshTWin(p);
   END; {DelTWinLines}


  PROCEDURE SetTWinColor(p:TWinPtr;TextCol,BckCol:BYTE);

   BEGIN
        p^.TextCol:=TextCol;
        p^.BckCol:=BckCol;
        IF p^.Visible THEN BEGIN
                                HydeTWin(p);
                                RefreshTWin(p);
                                END;
   END; {SetTWinColor}

 END.