{***************************************************************************
 *                                                                         *
 *                    Unit de calcul de POWER-GRAPH                       *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

UNIT PG_CALC;

INTERFACE

 USES
     PG_Ptrs;


 CONST
      Eps=1E-4;
      Eps2=1E-8;
      Pi=3.1415926;


 FUNCTION Puis(X:REAL;Y:WORD):REAL;
 PROCEDURE CProjectInit(N:ProjectPtr;VAR M:CProjectPtr);
 PROCEDURE XCopy(P:XPtr;VAR Q:XPtr);
 PROCEDURE XYZAdd(VAR Q:XYZPtr;P:XYZPtr);
 PROCEDURE XYZPolyAdd(VAR Q:XYZPtr;P:XYZPtr);
 PROCEDURE Add_All_QXY_to_QY(N:CProjectPtr;y:REAL);
 PROCEDURE Add_All_QXYZ_to_Q(N:CProjectPtr;y:REAL;z:REAL);
 PROCEDURE Copy_All_QX_to_QY(N:CProjectPtr);
 PROCEDURE Copy_All_QY_to_Q(N:CProjectPtr);
 PROCEDURE Del_All_Q(n:CProjectPtr);
 PROCEDURE Del_All_QY(n:CProjectPtr);
 PROCEDURE Normale(N:CProjectPtr;x,y,z:REAL;VAR nor:VEC3);

 FUNCTION Roots(P:XPtr):VecPtr;

 PROCEDURE FindRoots(N:CProjectPtr;VAR V:StructPtr);
 PROCEDURE Choose(V:StructPtr;VAR Xp:RealPtr;VAR E:CProjectPtr);

 PROCEDURE Add_XYZ_to_X(VAR Q:XPtr;P:XYZPtr;y,z:REAL);


IMPLEMENTATION

 PROCEDURE XCopy(P:XPtr;VAR Q:XPtr);

  BEGIN
       IF P<>NIL THEN BEGIN
          NEW(Q);Q^.Next:=NIL;
          Q^.c:=P^.c;Q^.x:=P^.x;
       XCopy(P^.Next,Q^.Next);
       END;
  END; {XCopy}


 FUNCTION Puis(X:REAL;Y:WORD):REAL;

  BEGIN
       IF Y=0 THEN Puis:=1
              ELSE Puis:=X*Puis(X,Y-1);
  END; {Puis}


 FUNCTION Dot(x,y:Vec3):REAL;

  BEGIN Dot:=x[1]*y[1]+x[2]*y[2]+x[3]*y[3];
  END; {Dot}


 PROCEDURE Add_XYZ_to_X(VAR Q:XPtr;P:XYZPtr;y,z:REAL);

  VAR r:REAL;

  BEGIN
       IF Q=NIL THEN BEGIN;NewX(Q);Add_XYZ_to_X(Q,P,y,z);EXIT;END;
       r:=P^.c*Puis(y,p^.y)*Puis(z,P^.z);
       IF r=0 THEN EXIT;
       IF Q^.x=P^.x THEN BEGIN
                              Q^.c:=Q^.c+r;
                              EXIT;
                         END;
       IF Q^.Next<>NIL
          THEN Add_XYZ_to_X(Q^.Next,P,y,z)
          ELSE BEGIN
                    NEW(Q^.Next);Q^.Next^.Next:=NIL;
                    Q^.Next^.x:=P^.x;
                    Q^.Next^.c:=r;
               END;
  END; {Add_XYZ_to_X}


 PROCEDURE Add_XYZ_to_XY(VAR Q:XYPtr;P:XYZPtr);

  BEGIN
       IF Q=NIL THEN BEGIN NewXY(Q);Add_XYZ_to_XY(Q,P);EXIT;END;
       IF ((Q^.X=P^.X) AND (Q^.Y=P^.Y))
          THEN BEGIN Q^.c:=Q^.c+P^.c;EXIT;END;
       IF Q^.Next<>NIL THEN Add_XYZ_to_XY(Q^.Next,P)
                       ELSE BEGIN
                                 NEW(Q^.Next);Q^.Next^.Next:=NIL;
                                 Q^.Next^.x:=P^.x;
                                 Q^.Next^.y:=P^.y;
                                 Q^.Next^.c:=P^.c;
                            END;
  END; {Add_XYZ_to_XY}


 PROCEDURE XYZAdd(VAR Q:XYZPtr;P:XYZPtr);
  { Ajoute le 1er monme de P  Q }

  BEGIN
       IF Q=NIL THEN BEGIN NewXYZ(Q);XYZAdd(Q,P);EXIT;END;
       IF ((Q^.X=P^.X) AND (Q^.Y=P^.Y) AND (Q^.Z=P^.Z))
          THEN BEGIN Q^.c:=Q^.c+P^.c;EXIT;END;
       IF Q^.Next<>NIL THEN XYZAdd(Q^.Next,P)
                       ELSE BEGIN
                                 NEW(Q^.Next);Q^.Next^.Next:=NIL;
                                 Q^.Next^.x:=P^.x;
                                 Q^.Next^.y:=P^.y;
                                 Q^.Next^.z:=P^.z;
                                 Q^.Next^.c:=P^.c;
                            END;
  END; {XYZAdd}


 PROCEDURE XYZPolyAdd(VAR Q:XYZPtr;P:XYZPtr);

  BEGIN
       XYZAdd(Q,P);
       IF P^.Next<>NIL
          THEN XYZPolyAdd(Q,P^.Next);
  END; {XYZPolyAdd}


 PROCEDURE DeriveX(P:XYZPtr;VAR Q:XYZPtr);

  VAR P1:XYZPtr;

  BEGIN
       IF P^.x<>0 THEN BEGIN
                            NEW(P1);
                            P1^.x:=P^.x-1;
                            P1^.y:=P^.y;
                            P1^.z:=P^.z;
                            P1^.c:=P^.c*P^.x;
                            XYZAdd(Q,P1);
                            DISPOSE(P1);
                            END;
       IF P^.Next<>NIL THEN DeriveX(P^.Next,Q);
  END; {DeriveX}


 PROCEDURE DeriveY(P:XYZPtr;VAR Q:XYZPtr);

  VAR P1:XYZPtr;

  BEGIN
       IF P^.y<>0 THEN BEGIN
                            NEW(P1);
                            P1^.x:=P^.x;
                            P1^.y:=P^.y-1;
                            P1^.z:=P^.z;
                            P1^.c:=P^.c*P^.y;
                            XYZAdd(Q,P1);
                            DISPOSE(P1);
                            END;
       IF P^.Next<>NIL THEN DeriveY(P^.Next,Q);
  END; {DeriveY}


 PROCEDURE DeriveZ(P:XYZPtr;VAR Q:XYZPtr);

  VAR P1:XYZPtr;

  BEGIN
       IF P^.z<>0 THEN BEGIN
                            NEW(P1);
                            P1^.x:=P^.x;
                            P1^.y:=P^.y;
                            P1^.z:=P^.z-1;
                            P1^.c:=P^.c*P^.z;
                            XYZAdd(Q,P1);
                            DISPOSE(P1);
                            END;
       IF P^.Next<>NIL THEN DeriveZ(P^.Next,Q);
  END; {DeriveZ}


 PROCEDURE Add_X_to_X(VAR Q:XPtr;P:XPtr);

  BEGIN
       IF Q=NIL THEN BEGIN NewX(Q);Add_X_to_X(Q,P);EXIT;END;
       IF Q^.X=P^.X
          THEN BEGIN Q^.c:=Q^.c+P^.c;EXIT;END;
       IF Q^.Next<>NIL THEN Add_X_to_X(Q^.Next,P)
                       ELSE BEGIN
                                 NEW(Q^.Next);Q^.Next^.Next:=NIL;
                                 Q^.Next^.x:=P^.x;
                                 Q^.Next^.c:=P^.c;
                            END;
  END; {Add_X_to_X}


 PROCEDURE Derive(P:XPtr;VAR Q:XPtr);

  PROCEDURE Derive1(P:XPtr;VAR Q:XPtr);

   VAR P1:XPtr;

   BEGIN
        IF P^.x<>0 THEN BEGIN
                             NEW(P1);
                             P1^.x:=P^.x-1;
                             P1^.c:=P^.c*P^.x;
                             Add_X_to_X(Q,P1);
                             DISPOSE(P1);
                             END;
        IF  P^.Next<>NIL THEN Derive1(P^.Next,Q);
   END; {Derive1}

  BEGIN
       Q:=NIL;
       Derive1(P,Q);
  END; {Derive}


 FUNCTION XYZEval(P:XYZPtr;X,Y,Z:REAL):REAL;

  VAR dum:REAL;

  BEGIN
       IF P=NIL
          THEN XYZEval:=0
          ELSE XYZEval:=P^.c*Puis(X,P^.x)*Puis(Y,P^.y)*Puis(Z,P^.z)+
                                                       XYZEval(P^.Next,X,Y,Z);
  END; {XYZEval}



 FUNCTION XEval(P:XPtr;X:REAL):REAL;

  VAR dum:REAL;

  BEGIN
       IF P=NIL
          THEN XEval:=0
          ELSE XEval:=P^.c*Puis(X,P^.x)+XEval(P^.Next,X);
  END; {XEval}


 FUNCTION Newton(P:XPtr;R:REAL):REAL;

  VAR P1:XPtr;
      u:REAL;

  BEGIN
       Derive(P,P1);
       REPEAT
             u:=R;
             R:=R-XEval(P,R)/XEval(P1,R);
       UNTIL ABS(u-R)<Eps;
       DelXPol(P1);
       Newton:=R;
  END; {Newton}


 FUNCTION Roots(P:XPtr):VecPtr;

  VAR a:REAL;
      D:WORD;

  FUNCTION Roots1(P:XPtr;I:VecPtr):VecPtr;

   VAR P1:XPtr;
       V,II:VecPtr;

   PROCEDURE NewV;
    BEGIN
         IF V=NIL THEN BEGIN
                          NewVec(V);
                          Roots1:=V;
                          END
                ELSE BEGIN
                          NewVec(V^.Next);
                          V:=V^.Next;
                          END;
    END; {NewV}

   BEGIN Roots1:=NIL;
         V:=NIL;

         IF P^.Next=NIL THEN BEGIN a:=P^.c; {Traitement}
                                   D:=0;        {deg=0}
                                   EXIT;
                             END;

         IF I=NIL THEN BEGIN                {Cration I}
                             Derive(P,P1);
                             I:=Roots1(P1,NIL);INC(D);
                             DelXPol(P1);
                       END;

         IF D=1 THEN BEGIN NewVec(V); {Traitement deg=1 au retour ascenseur}
                           IF a<>0
                              THEN V^.Val:=-P^.c/a
                              ELSE V^.Val:=0;
                           Roots1:=V;
                           EXIT;
                     END;

         IF I=NIL THEN BEGIN
                            NEW(V);
                            V^.Val:=Newton(P,0);
                            V^.Next:=NIL;
                            Roots1:=V;
                            EXIT;
                       END;


         IF ABS(XEval(P,I^.Val))<Eps2
            THEN BEGIN NewV;V^.Val:=I^.Val;END
            ELSE IF Odd(D) XOR (a*XEval(P,I^.Val)<0)    {Branche -INF}
                    THEN BEGIN
                              NewVec(V);Roots1:=V;
                              V^.Val:=Newton(P,I^.Val-1);
                         END;

         WHILE I^.Next<>NIL DO BEGIN      {Intervalles ferms}
               II:=I^.Next;
               IF ABS(XEval(P,I^.Val))>Eps2
                  THEN IF ABS(XEval(P,II^.Val))<Eps2
                          THEN BEGIN NewV;V^.Val:=II^.Val;END
                          ELSE
                            IF Xeval(P,I^.Val)*Xeval(P,II^.Val)<0
                               THEN BEGIN
                                         NewV;
                                         V^.Val:=Newton(P,(I^.Val+II^.Val)/2);
                                         END;
               DISPOSE(I);
               I:=II;
         END;

         IF ABS(XEval(P,I^.Val))>Eps2
            THEN IF a*Xeval(P,I^.Val)<0
                    THEN BEGIN IF V=NIL     {Branche +INF}
                                  THEN BEGIN NewVec(V);
                                             Roots1:=V;
                                             END
                                  ELSE BEGIN NewVec(V^.Next);
                                             V:=V^.Next;
                                             END;
                                  V^.Val:=Newton(P,I^.Val+1);
                               END;
         DISPOSE(I);
   END; {Roots1}


  BEGIN a:=0;
        Roots:=Roots1(P,NIL);
  END;  {Roots}


 PROCEDURE Normale(N:CProjectPtr;x,y,z:REAL;VAR nor:VEC3);

  VAR V:XYZPtr;
      r:REAL;

  BEGIN
       Nor[1]:=XYZEval(N^.Nx,x,y,z);
       Nor[2]:=XYZEval(N^.Ny,x,y,z);
       Nor[3]:=XYZEval(N^.Nz,x,y,z);
       r:=SQRT(SQR(Nor[1])+SQR(Nor[2])+SQR(Nor[3]));
       IF r=0 THEN EXIT;
       Nor[1]:=Nor[1]/r;Nor[2]:=Nor[2]/r;Nor[3]:=Nor[3]/r;
  END; {Normale}


 PROCEDURE CProjectInit(N:ProjectPtr;VAR M:CProjectPtr);

   PROCEDURE Traite(P:XYZPtr;VAR QX:XPtr;VAR QXY:XYPtr;VAR QXYZ:XYZPtr);

    BEGIN
         IF P^.z=0
            THEN IF P^.y=0
                 THEN Add_XYZ_to_X(QX,P,0,0)
                 ELSE Add_XYZ_to_XY(QXY,P)
            ELSE XYZAdd(QXYZ,P);
         IF P^.Next<>NIL
            THEN Traite(P^.Next,QX,QXY,QXYZ);
    END;{Traite}

   PROCEDURE MakeCEqu(N:EquPtr;VAR M:CEquPtr);

    BEGIN
         IF N<>NIL THEN BEGIN
                             NewCEqu(M);
                             M^.P:=N^.P;
                             MakeCEqu(N^.Next,M^.Next);
                          END
                   ELSE M:=NIL;
    END; {MakeCEqu}

   PROCEDURE MakeCProject(N:ProjectPtr;VAR M:CProjectPtr);

    BEGIN
         IF N<>NIL THEN BEGIN
                             NewCProject(M);
                             M^.P:=N^.P;
                             M^.Coul:=N^.Coul;
                             MakeCEqu(N^.Cond,M^.Cond);
                             MakeCProject(N^.Next,M^.Next);
                          END
                   ELSE M:=NIL;
    END; {MakeCProject}


  VAR
     Tc:CEquPtr;

  BEGIN
       IF N<>NIL THEN
          BEGIN
               MakeCProject(N,M);
               IF M^.P<>NIL THEN BEGIN
                                      M^.QX:=NIL;M^.QXY:=NIL;M^.QXYZ:=NIL;
                                      Traite(M^.P,M^.QX,M^.QXY,M^.QXYZ);
                                 END;
               WITH M^ DO BEGIN
                              DeriveX(P,Nx);
                              DeriveY(P,Ny);
                              DeriveZ(P,Nz);
                         END;
               Tc:=M^.Cond;
               WHILE Tc<>NIL DO BEGIN
                     IF Tc^.P<>NIL THEN BEGIN
                                      Tc^.QX:=NIL;Tc^.QXY:=NIL;Tc^.QXYZ:=NIL;
                                      Traite(Tc^.P,Tc^.QX,Tc^.QXY,Tc^.QXYZ);
                                      END;
                     Tc:=Tc^.Next;
               END;
          END;
       IF N^.Next<>NIL THEN CProjectInit(N^.Next,M^.Next);
  END;{CProjectInit}


 PROCEDURE Add_All_QXY_to_QY(N:CProjectPtr;y:REAL);

    VAR TmpR:REAL;

   PROCEDURE XAdd1(P:XYPtr;VAR Q:XPtr);

    BEGIN
         IF Q^.x=P^.x
            THEN BEGIN Q^.c:=Q^.c+TmpR;EXIT;END;
         IF Q^.Next<>NIL THEN XAdd1(P,Q^.Next)
                         ELSE BEGIN
                                   NEW(Q^.Next);Q^.Next^.Next:=NIL;
                                   Q^.Next^.x:=P^.x;
                                   Q^.Next^.c:=TmpR;
                              END;
    END; {XAdd1}

   PROCEDURE XAdd2(P:XYPtr;VAR Q:XPtr);

    BEGIN
         TmpR:=Puis(y,P^.y)*P^.c;
         IF ABS(TmpR)<Eps2 THEN TmpR:=0;
         IF TmpR<>0
            THEN XAdd1(P,Q);
         IF P^.Next<>NIL THEN XAdd2(P^.Next,Q);
    END; {XAdd2}

   PROCEDURE XAddCond(VAR E:CEquPtr);

    BEGIN
         IF E^.QXY<>NIL THEN XAdd2(E^.QXY,E^.QY);
         IF E^.Next<>NIL THEN XAddCond(E^.Next);
    END; {XAddCond}

  BEGIN
       IF N^.QXY<>NIL THEN XAdd2(N^.QXY,N^.QY);
       IF N^.Cond<>NIL THEN XAddCond(N^.Cond);
       IF N^.Next<>NIL THEN Add_All_QXY_to_QY(N^.Next,y);
  END; {Add_All_QXY_to_QY}


 PROCEDURE Add_All_QXYZ_to_Q(N:CProjectPtr;y:REAL;z:REAL);

   VAR TmpR:REAL;

   PROCEDURE XAdd1(P:XYZPtr;VAR Q:XPtr);

    VAR re:REAL;

    BEGIN
         IF Q^.x=P^.x
            THEN BEGIN
                      Q^.c:=Q^.c+TmpR;EXIT;END;
         IF Q^.Next<>NIL THEN XAdd1(P,Q^.Next)
                         ELSE BEGIN
                                   NEW(Q^.Next);Q^.Next^.Next:=NIL;
                                   Q^.Next^.x:=P^.x;
                                 Q^.Next^.c:=TmpR;
                              END;
    END; {XAdd1}

   PROCEDURE XAdd2(P:XYZPtr;VAR Q:XPtr);

    BEGIN
         TmpR:=Puis(y,P^.y)*Puis(z,P^.z)*P^.c;
         IF ABS(TmpR)<Eps2 THEN TmpR:=0;
         IF TmpR<>0
            THEN XAdd1(P,Q);
         IF P^.Next<>NIL THEN XAdd2(P^.Next,Q);
    END; {XAdd2}

   PROCEDURE XAddCond(VAR E:CEquPtr);

    BEGIN
         IF E^.QXY<>NIL THEN XAdd2(E^.QXYZ,E^.Q);
         IF E^.Next<>NIL THEN XAddCond(E^.Next);
    END; {XAddCond}

  BEGIN
       IF N^.QXYZ<>NIL THEN XAdd2(N^.QXYZ,N^.Q);
       IF N^.Cond<>NIL THEN XAddCond(N^.Cond);
       IF N^.Next<>NIL THEN Add_All_QXYZ_to_Q(N^.Next,y,z);
  END; {Add_All_QXYZ_to_Q}


 PROCEDURE Copy_All_QX_to_QY(N:CProjectPtr);

  VAR Tc:CEquPtr;

  BEGIN
       WHILE N<>NIL DO BEGIN
             XCopy(N^.QX,N^.QY);
             Tc:=N^.Cond;
             WHILE Tc<>NIL DO BEGIN
                   XCopy(Tc^.QX,Tc^.QY);
                   Tc:=Tc^.Next;
             END;
             N:=N^.Next;
       END;
  END; {Copy_All_QX_to_QY}


 PROCEDURE Copy_All_QY_to_Q(N:CProjectPtr);

  VAR Tc:CEquPtr;

  BEGIN
       WHILE N<>NIL DO BEGIN
             XCopy(N^.QY,N^.Q);
             Tc:=N^.Cond;
             WHILE Tc<>NIL DO BEGIN
                   XCopy(Tc^.QY,Tc^.Q);
                   Tc:=Tc^.Next;
             END;
             N:=N^.Next;
       END;
  END; {Copy_All_QY_to_Q}


 PROCEDURE Del_All_Q(n:CProjectPtr);

  VAR Tc:CEquPtr;

  BEGIN
       WHILE N<>NIL DO BEGIN
             DelXPol(N^.Q);
             Tc:=N^.Cond;
             WHILE Tc<>NIL DO BEGIN
                   DelXPol(Tc^.Q);
                   Tc:=Tc^.Next;
             END;
             N:=N^.Next;
       END;
  END; {Del_All_Q}


 PROCEDURE Del_All_QY(n:CProjectPtr);

  VAR Tc:CEquPtr;

  BEGIN
       WHILE N<>NIL DO BEGIN
             DelXPol(N^.QY);
             Tc:=N^.Cond;
             WHILE Tc<>NIL DO BEGIN
                   DelXPol(Tc^.QY);
                   Tc:=Tc^.Next;
             END;
             N:=N^.Next;
       END;
  END; {Del_All_QY}


 PROCEDURE FindRoots(N:CProjectPtr;VAR V:StructPtr);

  VAR W:VecPtr;

  BEGIN
       W:=Roots(N^.Q);
       IF W<>NIL THEN BEGIN
                           NEW(V);
                           V^.Vals:=W;
                           V^.Eq:=N;
                           V^.Next:=NIL;
                           IF N^.Next<>NIL THEN FindRoots(N^.Next,V^.Next);
                      END
                 ELSE BEGIN
                           V:=NIL;
                           IF N^.Next<>NIL THEN FindRoots(N^.Next,V);
                      END;
  END; {FindRoots}


  PROCEDURE Choose(V:StructPtr;VAR Xp:RealPtr;VAR E:CProjectPtr);

   VAR vv:VecPtr;
       vw:StructPtr;
       r:REAL;
       Cond:BOOLEAN;
       Tc:CEquPtr;

   BEGIN
        r:=1;
        WHILE V<>NIL DO BEGIN
              WHILE V^.Vals<>NIL DO BEGIN
                    Cond:=TRUE;
                    Tc:=V^.Eq^.Cond;
                    WHILE Cond AND (Tc<>NIL) DO BEGIN
                          Cond:=(XEval(Tc^.Q,V^.Vals^.Val)>=0);
                          Tc:=Tc^.Next;
                    END;
                    IF Cond AND (V^.Vals^.Val<=0) AND ((V^.Vals^.Val>r) OR (r=1))
                       THEN BEGIN r:=V^.Vals^.Val;E:=V^.Eq;END;
                    vv:=V^.Vals^.Next;
                    DISPOSE(V^.Vals);
                    V^.Vals:=vv;
              END;
              vw:=V^.Next;DISPOSE(V);V:=vw;
        END;
        IF r=1 THEN Xp:=NIL ELSE Xp:=ADDR(r);
   END; {Choose}


END.
