{***************************************************************************
 *                                                                         *
 *                Unit d'entres au clavier de POWER-GRAPH                *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

UNIT PG_Clav;

INTERFACE

 USES
     Crt,
     DTWin,

     PG_Calc,
     PG_TxScr,
     PG_Ptrs;

 PROCEDURE EnterSurf(VAR n:ProjectPtr);
 PROCEDURE EnterCond(VAR n:EquPtr);
 PROCEDURE Parse(s:STRING;VAR P:XYZPtr);


IMPLEMENTATION

 FUNCTION MinNonNul(a,b:WORD):WORD;

  BEGIN
       IF ((a<b) AND (a>0)) OR (b=0) THEN MinNonNul:=a ELSE MinNonNul:=b;
  END; {MinNonNul}


 FUNCTION Max(a,b:WORD):WORD;

  BEGIN
       IF a>b THEN Max:=a ELSE Max:=b;
  END; {Max}


 PROCEDURE Count(P:XYZPtr;VAR Size:WORD);

  BEGIN
       Size:=0;
       REPEAT
             INC(Size,LENGTH(One_XYZ_to_Str(P)));
             P:=P^.Next;
       UNTIL P=NIL;
  END; {Count}


PROCEDURE Parse(s:STRING;VAR P:XYZPtr);

 VAR Mon:STRING;
     i:WORD;
     x,y,z,m:BYTE;
     c:INTEGER;
     q:XYZPol;

 BEGIN
      q.Next:=NIL;
      i:=1+MinNonNul(POS('+',COPY(s,2,LENGTH(s)-1)),
                                             POS('-',COPY(s,2,LENGTH(s)-1)));
      IF i=1 THEN Mon:=s ELSE
         Mon:=COPY(s,1,i-1);
      x:=POS('x',Mon);
      y:=POS('y',Mon);
      z:=POS('z',Mon);
      IF Max(Max(x,y),z)=0
         THEN VAL(Mon,Q.c,c)
         ELSE IF (x=1)OR(y=1)OR(z=1)
                 THEN Q.c:=1
                 ELSE IF (x=2)OR(y=2)OR(z=2)
                     THEN IF Mon[1]='+'
                             THEN Q.c:=1
                             ELSE IF Mon[1]='-'
                                  THEN Q.c:=-1
                                  ELSE ASM;NOP;END
                     ELSE BEGIN
                          VAL(COPY(Mon,1,MinNonNul(MinNonNul(x,y),z)-1),Q.c,c);
                          IF ABS(Q.c)<Eps2 THEN Q.c:=0;
                          END;
      IF x=0 THEN Q.x:=0
             ELSE BEGIN
                  IF y>x THEN IF (z>y) OR (z<x) THEN m:=y-x-1
                                                ELSE m:=z-x-1
                         ELSE IF z>x THEN m:=z-x-1
                                     ELSE m:=LENGTH(Mon)-x;
                  IF m=0 THEN Q.x:=1
                         ELSE VAL(COPY(s,x+1,m),Q.x,c);
                  END; {x<>0}

      IF y=0 THEN Q.y:=0
             ELSE BEGIN
                  IF z>y THEN IF (x>z) OR (x<y) THEN m:=z-y-1
                                                ELSE m:=x-y-1
                         ELSE IF x>y THEN m:=x-y-1
                                     ELSE m:=LENGTH(Mon)-y;
                  IF m=0 THEN Q.y:=1
                         ELSE VAL(COPY(s,y+1,m),Q.y,c);
                  END; {y<>0}

      IF z=0 THEN Q.z:=0
             ELSE BEGIN
                  IF x>z THEN IF (y>x) OR (y<z) THEN m:=x-z-1
                                                ELSE m:=y-z-1
                         ELSE IF y>z THEN m:=y-z-1
                                     ELSE m:=LENGTH(Mon)-z;
                  IF m=0 THEN Q.z:=1
                         ELSE VAL(COPY(s,z+1,m),Q.z,c);
                  END; {z<>0}

      IF Q.c<>0 THEN XYZAdd(P,Addr(Q));
      IF i>1 THEN Parse(COPY(s,i,Length(s)-i+1),P);
 END; {Parse}


 PROCEDURE EnterSurf(VAR n:ProjectPtr);

 VAR
    s:STRING;
    w:TWinPtr;

 BEGIN
      WINDOW(1,1,80,25);
      OpenTWin(w,10,3,70,20,Cadre+DoubleHoriz,58,21);
      TWinWrite(w,5,2,'Ajout d''une surface');
      TWinwrite(w,1,4,'Equation : ');
      WINDOW(11,8,69,19);
      READLN(s);
      WINDOW(1,1,80,25);
      IF s<>'' THEN BEGIN
                         NewProject(n);
                         Parse(s,n^.p);
                         Count(n^.p,n^.Size);
                         ClearTWin(w);
                         TWinWrite(w,10,8,'Nom de cet objet : ');
                         WINDOW(39,11,59,11);
                         READLN(n^.Name);
                         WINDOW(1,1,80,25);
                         TWinWrite(w,13,10,'Couleur : ');
                         WINDOW(33,13,34,13);
                         READLN(n^.coul);
                         WINDOW(1,1,80,25);
                    END;
      CloseTWin(w);
 END; {EnterSurf}


 PROCEDURE EnterCond(VAR n:EquPtr);

 VAR
    w:TWinPtr;
    s:STRING;

 BEGIN
      WINDOW(1,1,80,25);
      OpenTWin(w,10,3,70,20,Cadre+DoubleHoriz,58,21);
      TWinWrite(w,5,2,'Ajout d''une condition');
      TWinwrite(w,1,4,'Equation : ');
      WINDOW(11,8,69,19);
      READLN(s);
      WINDOW(1,1,80,25);
      IF s<>'' THEN BEGIN
                         NewEqu(n);
                         Parse(s,n^.p);
                         Count(n^.p,n^.Size);
                         ClearTWin(w);
                         TWinWrite(w,10,8,'Nom de cet condition : ');
                         WINDOW(43,11,63,11);
                         READLN(n^.Name);
                         WINDOW(1,1,80,25);
                    END;
      ClrScr;
 END; {EnterCond}

END.
