{***************************************************************************
 *                                                                         *
 *             Unit de gestion des E/S Disque de POWER-GRAPH              *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

UNIT PG_Disk;

INTERFACE

 USES
     DOS,
     Crt,
     Graph,

     Console,

     PG_Ptrs,
     PG_GrScr,
     PG_Parch,
     PG_TxScr;

 TYPE
     PGFile=FILE OF REAL;
     PGFile0=FILE;

 CONST
      PG_Version:BYTE=1;

 VAR
    ImgPath,PGPath:STRING;

    FUNCTION FileExists(s:STRING):BOOLEAN;
    PROCEDURE ListeRepert;
    PROCEDURE ChangeRep;
    PROCEDURE Save(l:ProjListPtr);
    PROCEDURE Load(VAR l:ProjListPtr);

IMPLEMENTATION

 TYPE tab=ARRAY[1..3] OF WORD;

 VAR Path:STRING;
     IOr:WORD;


 FUNCTION FileExists(s:STRING):BOOLEAN;

  VAR f:FILE;

  BEGIN
       ASSIGN(f,s);
       {$I-}
       RESET(f);
       CLOSE(f);
       {$I+}
       FileExists:=(IOResult=0);
  END; {FileExists}


 PROCEDURE ListeRepert;

  VAR DirInfo:SearchRec;
      FileParch:POINTER;
      i:INTEGER;
      RStop:BOOLEAN;
      Ch:CHAR;

  BEGIN
       GrayOnBlack;
       WINDOW(1,TreeHi+2,80,25);
       ClrScr;
       WRITELN('Rpertoire courant : ',Path);
       WINDOW(1,1,80,25);
       FindFirst(Path+'*.PGS',Archive, DirInfo);
       NewParch(FileParch,12,0);
       WHILE DosError = 0 DO BEGIN
             AddParchLines(FileParch,ParchLength(FileParch)+1,1);
             ParchWrite(FileParch,1,ParchLength(FileParch),DirInfo.Name);
             FindNext(DirInfo);
       END;
       i:=1;
       RStop:=FALSE;
       REPEAT
             ColorWin(2,TreeHi+3,14,25,Black);
             ParchDisplay(FileParch,1,i,2,TreeHi+3,14,25,LightGray,Black);
             Ch:=ReadKey;
             If Ch=#0 THEN Ch:=ReadKey;
             CASE Ch OF
                  #72 : IF i>1
                           THEN DEC(i);                             {haut}
                  #80 : IF i<ParchLength(FileParch)-22+TreeHi
                           THEN INC(i);                             {bas}
                  #73 : IF i>22-TreeHi
                           THEN DEC(i,22-TreeHi)                    {PgUp}
                           ELSE i:=1;
                  #81 : IF i<ParchLength(FileParch)-2*(22-TreeHi)+1 {PgDn}
                           THEN INC(i,22-TreeHi)
                           ELSE i:=ParchLength(FileParch)-22+TreeHi;
                  #27 : RStop:=TRUE;
             END;
       UNTIL RStop;
       DelParch(FileParch);
  END; {ListeRepert}


 PROCEDURE ChangeRep;

  VAR p:STRING;

  BEGIN
       GrayOnBlack;
       ClrScr;
       WRITELN(#10,#10,'Chemin d''accs courant : ',Path);
       WRITE(#10,'  Nouveau chemin : ');
       READLN(p);
       IF p<>'' THEN Path:=p;
       ClrScr;
  END;


 PROCEDURE Save(l:ProjListPtr);

   VAR f:PGFile0;
       s:STRING[8];
       Ch:CHAR;
       i:BYTE;
       PosNbProj:LONGINT;
       LongEqu:LONGINT;
       NbCond:LONGINT;
       NbProject:LONGINT;

      PROCEDURE SaveXYZ(VAR f:PGFile0;p:XYZPtr;VAR LongEqu:LONGINT);

        BEGIN
             IF p=NIL THEN EXIT;
             BlockWrite(f,P^.x,2);
             BlockWrite(f,P^.y,2);
             BlockWrite(f,P^.z,2);
             BlockWrite(f,P^.c,6);
             INC(LongEqu);
             SaveXYZ(f,P^.Next,LongEqu);
        END; {SaveXYZ}

      PROCEDURE SaveCondList(VAR f:PGFile0;eq:EquPtr);

        VAR LongCond,PosLongCond,LongEqu:LONGINT;
            i:BYTE;

        BEGIN
             IF eq=NIL THEN EXIT;
          {*** Nom Condition ***}
             BlockWrite(f,eq^.Name,LENGTH(eq^.Name)+1);
          {*** Rservation place pour LongCond ***}
             PosLongCond:=FILEPOS(f);
             LongCond:=0;
             BlockWrite(f,LongCond,SizeOf(LongCond));
          {*** Ecriture condition ***}
             SaveXYZ(f,eq^.p,LongCond);
          {*** Ecriture LongCond ***}
             SEEK(f,PosLongCond);
             BlockWrite(f,LongCond,SizeOf(LongCond));
          {*** Condition suivante ***}
             SEEK(f,FileSize(f));
             INC(NbCond);
             SaveCondList(f,eq^.Next);
        END; {SaveCondList}


     PROCEDURE SaveProject(VAR f:PGFile0;n:ProjectPtr);

      VAR PosProject:LONGINT;
          i:BYTE;

      BEGIN
           IF n=NIL THEN EXIT;
        {*** Nom Surface ***}
           BlockWrite(f,n^.Name,LENGTH(n^.Name)+1);
        {*** Couleur ***}
           BlockWrite(f,n^.coul,SizeOf(n^.coul));
        {*** Rservation place Longueur quation/NbConditions ***}
           PosProject:=FILEPOS(f);
           LongEqu:=0;
           BlockWrite(f,LongEqu,SizeOf(LongEqu));
           NbCond:=0;
           BlockWrite(f,NbCond,SizeOf(NbCond));
        {*** Ecriture Equation et conditions ***}
           SaveXYZ(f,n^.P,LongEqu);
           NbCond:=0;
           SaveCondList(f,n^.cond);
        {*** Ecriture Longueur/NbConditions ***}
           SEEK(f,PosProject);
           BlockWrite(f,LongEqu,SizeOf(LongEqu));
           BlockWrite(f,NbCond,SizeOf(NbCond));
        {*** Surface suivante ***}
           SEEK(f,FileSize(f));
           INC(NbProject);
           SaveProject(f,n^.Next);
      END; {SaveProject}


   BEGIN
        GOTOXY(20,TreeHi+5);
        WRITE('Nom du fichier : ');READLN(s);
        Ch:='O';
        IF FileExists(path+s+'.PGS') THEN REPEAT
           WRITELN('Ce fichier existe !');
           WRITELN('On l''crase, dis ? ');
           Ch:=UpCase(ReadKey);
           UNTIL Ch IN ['O','N'];
           l:=NthProjList(l,Ord(PosInTree[1]));
        IF Ch<>'N' THEN BEGIN
           WRITELN('Je sauve "',l^.Name,'" dans ',path+s+'.PGS');
           REPEAT UNTIL KeyPressed;
           ASSIGN(f,path+s+'.PGS');
           REWRITE(f,1);
        {*** N de version du type de fichier ***}
           BlockWrite(f,PG_Version,1);
        {*** Nom du projet ***}
           BlockWrite(f,l^.Name,LENGTH(l^.Name)+1);
        {*** Palette graphique 16 couleurs ***}
           BlockWrite(f,l^.Pal,SizeOf(l^.Pal));
        {*** Rservation place pour NbProject ***}
           PosNbProj:=FILEPOS(f);
           NbProject:=0;
           BlockWrite(f,NbProject,SizeOf(NbProject));
        {*** Sauve Projet ***}
           SaveProject(f,l^.Proj);
        {*** Ecriture NbProject ***}
           SEEK(f,PosNbProj);
           BlockWrite(f,NbProject,SizeOf(NbProject));
           CLOSE(f);
        END;
        ClrScr;
   END; {Save}


 PROCEDURE Load(VAR l:ProjListPtr);

   TYPE tabb=ARRAY[1..6] OF BYTE;

   VAR f:PGFile0;
       s:STRING[12];
       r:REAL;
       i,j:BYTE;
       FichVersion:BYTE;
       NbProj:LONGINT;

      PROCEDURE LoadXYZ(VAR f:PGFile0;VAR p:XYZPtr;Nb:LONGINT);

        BEGIN
             IF Nb=0 THEN p:=NIL ELSE BEGIN
                NEW(p);
                WITH p^ DO BEGIN
                                BlockRead(f,x,2);
                                BlockRead(f,y,2);
                                BlockRead(f,z,2);
                                BlockRead(f,c,6);
                           END; {with}
                LoadXYZ(f,p^.Next,Nb-1);
             END; {ifte}
        END; {LoadXYZ}

      PROCEDURE LoadCondList(VAR f:PGFile0;VAR eq:EquPtr;Nb:LONGINT);

        VAR i,j:BYTE;

        BEGIN
             IF Nb=0 THEN eq:=NIL
                     ELSE BEGIN
                          NewEqu(eq);
                       {*** Lecture nom condition ***}
                          BlockRead(f,eq^.Name,1);
                          BlockRead(f,eq^.Name[1],LENGTH(eq^.Name));
                       {*** Lecture taille condition / lecture qu.}
                          BlockRead(f,NbProj,4);
                          LoadXYZ(f,eq^.p,NbProj);
                       {*** suivante ***}
                          LoadCondList(f,eq^.Next,Nb-1);
                     END; {ifte}
        END; {LoadCondList}


     PROCEDURE LoadProject(VAR f:PGFile0;VAR n:ProjectPtr;Nb:LONGINT);

       VAR i,j:BYTE;
           NbCond,LongEqu:LONGINT;

       BEGIN
            IF Nb=0 THEN n:=NIL ELSE BEGIN
               NEWProject(n);
            {*** Lecture nom surface ***}
               BlockRead(f,n^.Name,1);
               BlockRead(f,n^.Name[1],LENGTH(n^.Name));
            {*** Lecture Couleur/Longueur qu/Nb Conditions ***}
               BlockRead(f,n^.coul,1);
               BlockRead(f,LongEqu,4);
               BlockRead(f,NbCond,4);
               LoadXYZ(f,n^.p,LongEqu);
               LoadCondList(f,n^.cond,NbCond);
               LoadProject(f,n^.next,Nb-1);
            END; {ifte}
       END; {LoadProject}


   BEGIN
        GOTOXY(20,TreeHi+5);
        WRITE('Nom du fichier : ');READLN(s);
        IF s='' THEN EXIT;
        ASSIGN(f,path+s+'.PGS');
        {$I-}
        RESET(f,1);
        IF IOResult<>0
           THEN BEGIN
                WRITELN(Path+s,'.PGS n''existe pas !');
                WRITELN('Pressez une touche');
                REPEAT UNTIL KEYPRESSED;
                ClrScr;
                EXIT;
                END
           ELSE BEGIN
                New(l);l^.Next:=NIL;
                END;
        {$I+}
      {*** Lecture N de version ***}
         BlockRead(f,FichVersion,1);
      {*** Lecture Nom projet ***}
         BlockRead(f,l^.Name,1);
         BlockRead(f,l^.Name[1],LENGTH(l^.Name));
      {*** Lecture palette 16 couleurs ***}
         BlockRead(f,l^.Pal,SizeOf(l^.Pal));
      {*** Lecture Nb de surface / lecture surfaces ***}
         BlockRead(f,NbProj,4);
         LoadProject(f,l^.Proj,NbProj);
         CLOSE(f);
         ClrScr;
   END; {Load}


BEGIN
     GetDir(0,Path);
     PGPath:=Path;
     IF Path[LENGTH(Path)]<>'\' THEN Path:=Path+'\';
     {$I-}
     ChDir(Path+'IMG');
     IF IOResult=0
        THEN ImgPath:=Path+'IMG\'
        ELSE ImgPath:=Path;
     ChDir(Path+'PGS');
     {$I+}
     IF IORESULT=0
        THEN Path:=Path+'PGS\';
END.
