{***************************************************************************
 *                                                                         *
 *            Unit de Gestion d'cran graphique de PowerGraph             *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

UNIT PG_GrScr;

INTERFACE

USES
    Graph,
    Crt,
    Console,
    DTWin,

    PG_Ptrs;

TYPE {PaletteType=ARRAY[0..16] OF BYTE;}
     ColorType=ARRAY[1..MaxDeg,0..4] OF BYTE;
     Couleur=RECORD
                   Name:STRING[10];
                   Pal:ARRAY[0..2] OF BYTE;
             END;

CONST DefaultPalette:Palette=(Values:(Size:16;Colors:(0,63,8,1,9,16,2,18,32,4,36,24,3,27,0,63));
                              Names:('Bleu','Vert','Rouge','Cyan'));
      Colors: ColorType=((14,2,3,4,1),(14,5,6,7,1),(14,8,9,10,1),(14,11,12,13,1));
      NDegrade=7;
      ColList: ARRAY[1..NDegrade] OF Couleur=
               ((Name:'Bleu';Pal:(8,1,9)),
                (Name:'Vert';Pal:(16,2,18)),
                (Name:'Rouge';Pal:(32,4,36)),
                (Name:'Cyan';Pal:(24,3,27)),
                (Name:'Jaune';Pal:(48,6,54)),
                (Name:'Magenta';Pal:(40,5,45)),
                (Name:'Gris';Pal:(56,7,65)));


VAR
   YPos,ZPos:INTEGER;
   YCoef,ZCoef:REAL;
   NMode,ModNam,GMode,NewMode,Ncoul:BYTE;
   YMax,ZMax:WORD;
   ModeName:STRING[4];


  PROCEDURE InstallMode(M:BYTE;f:BOOLEAN);
  PROCEDURE ScrParam;
  PROCEDURE GrayOnBlack;
  PROCEDURE RegisterColor(c:Couleur;VAR p:Palette;n:BYTE);
  PROCEDURE ModifyPalette(l:ProjListPtr);

IMPLEMENTATION

PROCEDURE EgaVgaDriver;EXTERNAL;
{$L EgaVga.OBJ}


PROCEDURE RegisterColor(c:Couleur;VAR p:Palette;n:BYTE);

 VAR i:BYTE;

 BEGIN
      FOR i:=0 TO 2 DO
               p.Values.Colors[2+3*(n-1)+i]:=c.Pal[i];
      p.Names[n]:=c.Name;
 END; {RegisterColor}


PROCEDURE ModifyPalette(l:ProjListPtr);

 VAR
    w:TWinPtr;
    a,b,i:BYTE;
    s:STRING[2];

 BEGIN
      REPEAT
            OpenTWin(w,10,6,50,22,Cadre,38,15);
            TWinWrite(w,5,1,'Projet "'+l^.Name+'"');
            FOR i:=1 TO MaxDeg DO
                BEGIN
                     Str(i,s);
                     TWinWrite(w,20,2+i,s+' : '+l^.Pal.Names[i]);
                END;
            FOR i:=1 TO NDegrade DO
                BEGIN
                     Str(i,s);
                     TWinWrite(w,1,2+i,s+' : '+ColList[i].Name);
                END;
            TWinWrite(w,1,NDegrade+4,'Numro de la couleur  ajouter');
            TWinWrite(w,2,NDegrade+5,'(0 pour finir)');
            GOTOXY(12,12+NDegrade);
            WRITE('=> ');
            READLN(a);
            IF a<>0
               THEN BEGIN
                         TWinWrite(w,2,NDegrade+7,'Nouvelle rfrence de "'+ColList[a].Name+'"');
                         GOTOXY(12,14+NDegrade);
                         WRITE('=> ');
                         READLN(b);
                         RegisterColor(ColList[a],l^.Pal,b);
                    END;
            CloseTWin(w);
      UNTIL a=0;
 END; {ModifyPalette}


PROCEDURE InstallMode(M:BYTE;f:BOOLEAN);

 BEGIN
      CASE M OF
{           $0D : BEGIN ModeName:='EGA';YMax:=319;ZMax:=199;Ncoul:=15;END;}
           $0E : BEGIN ModeName:='EGA';YMax:=639;ZMax:=199;Ncoul:=15;ModNam:=EGA;nmode:=EGALo;END;
           $12 : BEGIN ModeName:='VGA';YMax:=639;ZMax:=479;Ncoul:=15;ModNam:=VGA;nmode:=VGAHi;END;
{           $13 : BEGIN ModeName:='VGA';YMax:=319;ZMax:=199;Ncoul:=255;END;
           $6A : BEGIN ModeName:='VESA';YMax:=799;ZMax:=599;Ncoul:=15;END;}
           ELSE BEGIN WRITELN('Mode non disponible  -  Frappez ENTER');
                      READLN;EXIT;END;
      END; {case}
      IF f THEN GMode:=M;
 END; {InstallMode}


PROCEDURE ScrParam;

BEGIN
     REPEAT
           GrayOnBlack;
           ClrScr;
           WRITE('Mode Graphique install : ');
           WRITELN(ModeName,' ',YMax+1,'x',ZMax+1,'  en ',Ncoul+1,' couleurs.');
           WRITELN;
           WRITE('Nouveau Mode (0 si OK) : ');
           READLN(NewMode);
           IF NewMode<>0 THEN InstallMode(NewMode,TRUE);
     UNTIL NewMode=0;
     ClrScr;
END; {ScrParam}


  PROCEDURE GrayOnBlack;
   BEGIN
        TextColor(LightGray);
        TextBackGround(Black);
   END; {GrayOnBlack}


BEGIN
     YPos:=RegisterBGIDriver(@EgaVgaDriver);
     YCoef:=50;ZCoef:=50;
     YPos:=0;ZPos:=0;
     InstallMode($12,TRUE);

END.
