{***************************************************************************
 *                                                                         *
 *                     Unit de gestion de parchemins                      *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

UNIT PG_Parch;

INTERFACE

 USES
     Crt;

 PROCEDURE NewParch(VAR p:POINTER;Larg,L0:BYTE);
 PROCEDURE AddParchLines(VAR p:POINTER;YPos,dY:BYTE);
 PROCEDURE DelParchLines(VAR p:POINTER;Li,Lf:BYTE);
 PROCEDURE ClearParch(p:POINTER);
 PROCEDURE ParchWrite(p:POINTER;x,y:BYTE;Str:STRING);
 PROCEDURE ParchDisplay(p:POINTER;Xp,Yp,Xs1,Ys1,Xs2,Ys2,TextCol,BckCol:BYTE);
 PROCEDURE DelParch(VAR p:POINTER);

 FUNCTION ParchWidth(p:POINTER):BYTE;
 FUNCTION ParchLength(p:POINTER):BYTE;

IMPLEMENTATION

 PROCEDURE NewParch(VAR p:POINTER;Larg,L0:BYTE);

  BEGIN
       GetMem(p,Larg*L0+2);
       WORD(p^):=Larg+256*L0;
       ClearParch(p);
  END; {NewParch}


 PROCEDURE AddParchLines(VAR p:POINTER;YPos,dY:BYTE);

  VAR Larg,L0:BYTE;
      p1:POINTER;
      i:WORD;

  BEGIN
       Larg:=BYTE(p^);L0:=HI(WORD(p^));
       GetMem(p1,Larg*(L0+dY)+2);
       WORD(p1^):=Larg+256*(L0+dY);
       FOR i:=2 TO 1+Larg*(YPos-1) DO
           MEM[SEG(p1^):OFS(p1^)+i]:=MEM[SEG(p^):OFS(p^)+i];
       FOR i:=2+Larg*(YPos-1) TO 1+Larg*(YPos+dY-1) DO
           MEM[SEG(p1^):OFS(p1^)+i]:=32;
       FOR i:=2+Larg*(YPos-1) TO 1+Larg*L0 DO
           MEM[SEG(p1^):OFS(p1^)+i+dY*Larg]:=MEM[SEG(p^):OFS(p^)+i];
       FreeMem(p,Larg*L0+2);
       p:=p1;
  END; {AddParchLines}


 PROCEDURE DelParchLines(VAR p:POINTER;Li,Lf:BYTE);

  VAR Larg,L0:BYTE;
      p1:POINTER;
      i:WORD;

  BEGIN
       Larg:=BYTE(p^);L0:=HI(WORD(p^));
       GetMem(p1,Larg*(L0-Lf+Li-1)+2);
       WORD(p1^):=Larg+256*(L0-Lf+Li-1);
       FOR i:=2 TO 1+Larg*(Li-1) DO
           MEM[SEG(p1^):OFS(p1^)+i]:=MEM[SEG(p^):OFS(p^)+i];
       FOR i:=2+Larg*Lf TO Larg*L0+1 DO
           MEM[SEG(p1^):OFS(p1^)+i-(Lf-Li+1)*Larg]:=MEM[SEG(p^):OFS(p^)+i];
       FreeMem(p,Larg*L0+2);
       p:=p1;
  END; {DelParchLines}


 PROCEDURE ClearParch(p:POINTER);

  VAR Larg,L0:BYTE;
      i:WORD;

  BEGIN
       Larg:=BYTE(p^);L0:=HI(WORD(p^));
       FOR i:=2 TO 1+Larg*L0 DO
           MEM[SEG(p^):OFS(p^)+i]:=32;
  END; {ClearParch}


 FUNCTION Min(x,y:WORD):WORD;
  BEGIN
       IF x<y THEN Min:=x ELSE Min:=y;
  END; {Min}


 PROCEDURE ParchWrite(p:POINTER;x,y:BYTE;Str:STRING);

  VAR Larg,L0:BYTE;
      i:WORD;

  BEGIN
       Larg:=BYTE(p^);L0:=HI(WORD(p^));
       IF y>L0 THEN EXIT;
       FOR i:=1 TO Min(LENGTH(Str),Larg*L0-Larg*(y-1)-x+1) DO
           MEM[SEG(p^):OFS(p^)+Larg*(y-1)+x+i]:=Ord(Str[i]);
  END; {ParchWrite}


 PROCEDURE ParchDisplay(p:POINTER;Xp,Yp,Xs1,Ys1,Xs2,Ys2,TextCol,BckCol:BYTE);

  VAR Larg,L0:BYTE;
      i,j:BYTE;

  BEGIN
       Larg:=BYTE(p^);L0:=HI(WORD(p^));
       IF (p=NIL) OR (L0=0) THEN EXIT;
       FOR j:=0 TO Min(Ys2-Ys1,L0-Yp) DO
           FOR i:=0 TO Min(Xs2-Xs1,Larg-Xp) DO
             BEGIN
              MEMW[$B800:2*((Ys1+j-1)*80+Xs1+i-1)]:=TextCol*$100+BckCol*$1000+
                   MEM[SEG(p^):OFS(p^)+Larg*(Yp+j-1)+Xp+1+i];
               END;
  END; {ParchDisplay}


 PROCEDURE DelParch(VAR p:POINTER);

  VAR Larg,L0:BYTE;

  BEGIN
       Larg:=BYTE(p^);L0:=HI(WORD(p^));
       FreeMem(p,Larg*L0+2);
  END; {DelParch}


 FUNCTION ParchWidth(p:POINTER):BYTE;
  BEGIN
       ParchWidth:=BYTE(p^);
  END; {ParchWidth}


 FUNCTION ParchLength(p:POINTER):BYTE;
  BEGIN
       ParchLength:=HI(WORD(p^));
  END; {ParchLength}

END.
