UNIT SaveScrn;

INTERFACE

 Uses
     Crt,
     Graph,

     PG_Disk,
     PG_GrScr;

 PROCEDURE WriteScreen;
 PROCEDURE ReadScreen(s:STRING);
 PROCEDURE SaveScreen(s:STRING);

IMPLEMENTATION

 PROCEDURE WriteScreen;

  VAR P:POINTER;
      f:FILE;
      i:BYTE;
      pal:PaletteType;

  BEGIN
       ASSIGN(f,ImgPath+'CURRENT.IMG');
       REWRITE(f,1);
       BlockWrite(f,GMode,1);
       GetPalette(pal);
       BlockWrite(f,pal,SizeOf(pal));
       CASE GMode OF
            $0E : BEGIN
                       GetMem(P,ImageSize(0,0,639,199));
                       GetImage(0,0,639,199,P^);
                       BlockWrite(f,P^,ImageSize(0,0,639,199));
                       FreeMem(P,ImageSize(0,0,639,199));
                  END;
            $12 : BEGIN
                       GetMem(P,ImageSize(0,0,639,159));
                       FOR i:=0 TO 2 DO
                           BEGIN
                                GetImage(0,160*i,639,160*i+159,P^);
                                BlockWrite(f,P^,ImageSize(0,0,639,159));
                           END;
                       FreeMem(P,ImageSize(0,0,639,159));
                  END;
            END; {case}
       Close(f);
  END; {WriteScreen}


 PROCEDURE ReadScreen(s:STRING);

  VAR P:POINTER;
      f:FILE;
      i:BYTE;
      driver,modegr:INTEGER;
      pal:PaletteType;

  BEGIN
       ASSIGN(f,ImgPath+s+'.IMG');
       RESET(f,1);
       BlockRead(f,GMode,1);
       BlockRead(f,pal,SizeOf(pal));
       InstallMode(GMode,TRUE);
       Driver:=ModNam;ModeGr:=nmode;
       InitGraph(Driver,ModeGr,PGPath);
       SetAllPalette(pal);
       CASE GMode OF
            $0E : BEGIN
                       GetMem(P,ImageSize(0,0,639,199));
                       BlockRead(f,P^,ImageSize(0,0,639,199));
                       PutImage(0,0,P^,NormalPut);
                       FreeMem(P,ImageSize(0,0,639,199));
                  END;
            $12 : BEGIN
                       GetMem(P,ImageSize(0,0,639,159));
                       FOR i:=0 TO 2 DO
                           BEGIN
                                BlockRead(f,P^,ImageSize(0,0,639,159));
                                PutImage(0,160*i,P^,NormalPut);
                           END;
                       FreeMem(P,ImageSize(0,0,639,159));
                  END;
            END; {case}
       REPEAT UNTIL KeyPressed;
       CloseGraph;
       Close(f);
  END; {ReadScreen}


 PROCEDURE SaveScreen(s:STRING);

  VAR f:FILE;

  BEGIN
       ASSIGN(f,ImgPath+'CURRENT.IMG');
       RENAME(f,ImgPath+s+'.IMG');
  END; {SaveScreen}

END.